# TPK4186 - Advanced Tools for Performance Engineering
# FallingBall.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random

depth = 4
numberOfExecutions = 1000000
buckets = [0 for i in range(0, 2**depth)]

for execution in range(1, numberOfExecutions+1):
  bucket = 0
  for d in range(0, depth):
    bucket = 2*bucket + random.randrange(0, 2)
  buckets[bucket] += 1

print("Bucket\t#balls\tFrequency")
for bucket in range(0, 2**depth):
  print(str(bucket) + "\t" + str(buckets[bucket]) + "\t" + str(buckets[bucket]/numberOfExecutions))
print("Exp." +"\t" + str(numberOfExecutions*2**-depth)  + "\t" + str(2**-depth))
